---
lang: en
title: 'API docs: openapi-spec-builder.builderbase'
keywords: LoopBack 4.0, LoopBack 4, Node.js, TypeScript, OpenAPI
sidebar: lb4_sidebar
editurl: https://github.com/loopbackio/loopback-next/tree/master/packages/openapi-spec-builder
permalink: /doc/en/lb4/apidocs.openapi-spec-builder.builderbase.html
---

<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@loopback/openapi-spec-builder](./openapi-spec-builder.md) &gt; [BuilderBase](./openapi-spec-builder.builderbase.md)

## BuilderBase class

**Signature:**

```typescript
export declare class BuilderBase<T extends ISpecificationExtension> 
```

## Constructors

<table><thead><tr><th>

Constructor


</th><th>

Modifiers


</th><th>

Description


</th></tr></thead>
<tbody><tr><td>

[(constructor)(initialSpec)](./openapi-spec-builder.builderbase._constructor_.md)


</td><td>


</td><td>

Constructs a new instance of the `BuilderBase` class


</td></tr>
</tbody></table>

## Properties

<table><thead><tr><th>

Property


</th><th>

Modifiers


</th><th>

Type


</th><th>

Description


</th></tr></thead>
<tbody><tr><td>

[\_spec](./openapi-spec-builder.builderbase._spec.md)


</td><td>

`protected`


</td><td>

T


</td><td>


</td></tr>
</tbody></table>

## Methods

<table><thead><tr><th>

Method


</th><th>

Modifiers


</th><th>

Description


</th></tr></thead>
<tbody><tr><td>

[build()](./openapi-spec-builder.builderbase.build.md)


</td><td>


</td><td>

Build the spec object.


</td></tr>
<tr><td>

[withExtension(key, value)](./openapi-spec-builder.builderbase.withextension.md)


</td><td>


</td><td>

Add a custom (extension) property to the spec object.


</td></tr>
</tbody></table>


